/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu;

import java.math.BigInteger;
import ru.ispras.microtesk.model.TemporaryVariables;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code TempVars} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TempVars extends TemporaryVariables {
  public final Memory SRC1;
  public final Memory SRC2;
  public final Memory DEST;

  private TempVars() {
    this.SRC1 = Memory.def(Memory.Kind.VAR, "SRC1", TypeDefs.BYTE, 1);
    this.SRC2 = Memory.def(Memory.Kind.VAR, "SRC2", TypeDefs.BYTE, 1);
    this.DEST = Memory.def(Memory.Kind.VAR, "DEST", TypeDefs.BYTE, 1);

    addVariable(SRC1);
    addVariable(SRC2);
    addVariable(DEST);
  }

  private static final class TempVarsFactory implements Factory {
    @Override
    public TempVars create() {
      return new TempVars();
    }
  }

  public static Factory newFactory() {
    return new TempVarsFactory();
  }
}
