/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86;

import ru.ispras.microtesk.model.ModelBuilder;
import ru.ispras.microtesk.model.x86.metadata.MetaModelFactory;
import ru.ispras.microtesk.model.x86.decoder.Decoder;
import ru.ispras.microtesk.model.x86.mode.*;
import ru.ispras.microtesk.model.x86.op.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model extends ModelBuilder {
  public Model() {
    super(
        "x86",
        MetaModelFactory.newMetaModel(),
        Decoder.get(),
        PE.newFactory(),
        TempVars.newFactory()
        );

    addMode(R16.INFO);
    addMode(RSEG16.INFO);
    addMode(R8.INFO);
    addMode(IMM8.INFO);
    addMode(IMM16.INFO);
    addMode(DOAM.INFO);
    addMode(RIAM_BX.INFO);
    addMode(RIAM_SI.INFO);
    addMode(RIAM_DI.INFO);
    addMode(BIAM_BX_SI.INFO);
    addMode(BIAM_BX_DI.INFO);
    addMode(BIAM_BP_SI.INFO);
    addMode(BIAM_BP_DI.INFO);
    addMode(IAM_BX_D8.INFO);
    addMode(IAM_BP_D8.INFO);
    addMode(IAM_SI_D8.INFO);
    addMode(IAM_DI_D8.INFO);
    addMode(BIDAM_BX_SI_D8.INFO);
    addMode(BIDAM_BX_DI_D8.INFO);
    addMode(BIDAM_BP_SI_D8.INFO);
    addMode(BIDAM_BP_DI_D8.INFO);
    addMode(IAM_BX_D16.INFO);
    addMode(IAM_BP_D16.INFO);
    addMode(IAM_SI_D16.INFO);
    addMode(IAM_DI_D16.INFO);
    addMode(BIDAM_BX_SI_D16.INFO);
    addMode(BIDAM_BX_DI_D16.INFO);
    addMode(BIDAM_BP_SI_D16.INFO);
    addMode(BIDAM_BP_DI_D16.INFO);

    addOperation(mov_m8r8.INFO);
    addOperation(mov_r8m8.INFO);
    addOperation(mov_r8r8.INFO);
    addOperation(mov_m16r16.INFO);
    addOperation(mov_r16r16.INFO);
    addOperation(mov_r16m16.INFO);
    addOperation(mov_r16rseg.INFO);
    addOperation(mov_m16rseg.INFO);
    addOperation(mov_rsegr16.INFO);
    addOperation(mov_rsegm16.INFO);
    addOperation(mov_r8i8.INFO);
    addOperation(mov_r16i16.INFO);
    addOperation(mov_m8i8.INFO);
    addOperation(mov_m16i16.INFO);
    addOperation(xchg_r8r8.INFO);
    addOperation(xchg_r8m8.INFO);
    addOperation(xchg_r16r16.INFO);
    addOperation(xchg_r16m16.INFO);
    addOperation(push_rseg.INFO);
    addOperation(push_r16.INFO);
    addOperation(push_m16.INFO);
    addOperation(pushA.INFO);
    addOperation(pop_rseg.INFO);
    addOperation(pop_r16.INFO);
    addOperation(pop_m16.INFO);
    addOperation(popA.INFO);
    addOperation(add_proc_byte.INFO);
    addOperation(add_proc_word.INFO);
    addOperation(add_m8r8.INFO);
    addOperation(add_m16r16.INFO);
    addOperation(add_r8r8.INFO);
    addOperation(add_r8m8.INFO);
    addOperation(add_r16r16.INFO);
    addOperation(add_r16m16.INFO);
    addOperation(add_r8i8.INFO);
    addOperation(add_m8i8.INFO);
    addOperation(add_r16i16.INFO);
    addOperation(add_m16i16.INFO);
    addOperation(adc_m8r8.INFO);
    addOperation(adc_m16r16.INFO);
    addOperation(adc_r8r8.INFO);
    addOperation(adc_r8m8.INFO);
    addOperation(adc_r16r16.INFO);
    addOperation(adc_r16m16.INFO);
    addOperation(adc_r8i8.INFO);
    addOperation(adc_m8i8.INFO);
    addOperation(adc_r16i16.INFO);
    addOperation(adc_m16i16.INFO);
    addOperation(sub_proc_byte.INFO);
    addOperation(sub_proc_word.INFO);
    addOperation(sub_m8r8.INFO);
    addOperation(sub_m16r16.INFO);
    addOperation(sub_r8r8.INFO);
    addOperation(sub_r8m8.INFO);
    addOperation(sub_r16r16.INFO);
    addOperation(sub_r16m16.INFO);
    addOperation(sub_r8i8.INFO);
    addOperation(sub_m8i8.INFO);
    addOperation(sub_r16i16.INFO);
    addOperation(sub_m16i16.INFO);
    addOperation(sbb_m8r8.INFO);
    addOperation(sbb_m16r16.INFO);
    addOperation(sbb_r8r8.INFO);
    addOperation(sbb_r8m8.INFO);
    addOperation(sbb_r16r16.INFO);
    addOperation(sbb_r16m16.INFO);
    addOperation(sbb_r8i8.INFO);
    addOperation(sbb_m8i8.INFO);
    addOperation(sbb_r16i16.INFO);
    addOperation(sbb_m16i16.INFO);
    addOperation(inc_proc_byte.INFO);
    addOperation(inc_proc_word.INFO);
    addOperation(inc_r8.INFO);
    addOperation(inc_m8.INFO);
    addOperation(inc_r16.INFO);
    addOperation(inc_m16.INFO);
    addOperation(dec_proc_byte.INFO);
    addOperation(dec_proc_word.INFO);
    addOperation(dec_r8.INFO);
    addOperation(dec_m8.INFO);
    addOperation(dec_r16.INFO);
    addOperation(dec_m16.INFO);
    addOperation(mul_r8.INFO);
    addOperation(mul_m8.INFO);
    addOperation(mul_r16.INFO);
    addOperation(mul_m16.INFO);
    addOperation(imul_r8.INFO);
    addOperation(imul_m8.INFO);
    addOperation(imul_r16.INFO);
    addOperation(imul_m16.INFO);
    addOperation(div_r8.INFO);
    addOperation(div_m8.INFO);
    addOperation(div_r16.INFO);
    addOperation(div_m16.INFO);
    addOperation(idiv_r8.INFO);
    addOperation(idiv_m8.INFO);
    addOperation(idiv_r16.INFO);
    addOperation(idiv_m16.INFO);
    addOperation(test_proc_byte.INFO);
    addOperation(test_proc_word.INFO);
    addOperation(test_r8r8.INFO);
    addOperation(test_m8r8.INFO);
    addOperation(test_r16r16.INFO);
    addOperation(test_m16r16.INFO);
    addOperation(test_r8i8.INFO);
    addOperation(test_m8i8.INFO);
    addOperation(test_r16i16.INFO);
    addOperation(test_m16i16.INFO);
    addOperation(and_r8r8.INFO);
    addOperation(and_m8r8.INFO);
    addOperation(and_r8m8.INFO);
    addOperation(and_r16r16.INFO);
    addOperation(and_m16r16.INFO);
    addOperation(and_r16m16.INFO);
    addOperation(and_r8i8.INFO);
    addOperation(and_m8i8.INFO);
    addOperation(and_r16i16.INFO);
    addOperation(and_m16i16.INFO);
    addOperation(or_proc_byte.INFO);
    addOperation(or_proc_word.INFO);
    addOperation(or_r8r8.INFO);
    addOperation(or_m8r8.INFO);
    addOperation(or_r8m8.INFO);
    addOperation(or_r16r16.INFO);
    addOperation(or_m16r16.INFO);
    addOperation(or_r16m16.INFO);
    addOperation(or_r8i8.INFO);
    addOperation(or_m8i8.INFO);
    addOperation(or_r16i16.INFO);
    addOperation(or_m16i16.INFO);
    addOperation(xor_proc_byte.INFO);
    addOperation(xor_proc_word.INFO);
    addOperation(xor_r8r8.INFO);
    addOperation(xor_m8r8.INFO);
    addOperation(xor_r8m8.INFO);
    addOperation(xor_r16r16.INFO);
    addOperation(xor_m16r16.INFO);
    addOperation(xor_r16m16.INFO);
    addOperation(xor_r8i8.INFO);
    addOperation(xor_m8i8.INFO);
    addOperation(xor_r16i16.INFO);
    addOperation(xor_m16i16.INFO);
    addOperation(not_r8.INFO);
    addOperation(not_m8.INFO);
    addOperation(not_r16.INFO);
    addOperation(not_m16.INFO);
    addOperation(neg_proc_byte.INFO);
    addOperation(neg_proc_word.INFO);
    addOperation(neg_r8.INFO);
    addOperation(neg_m8.INFO);
    addOperation(neg_r16.INFO);
    addOperation(neg_m16.INFO);
    addOperation(cmp_m8r8.INFO);
    addOperation(cmp_m16r16.INFO);
    addOperation(cmp_r8r8.INFO);
    addOperation(cmp_r8m8.INFO);
    addOperation(cmp_r16r16.INFO);
    addOperation(cmp_r16m16.INFO);
    addOperation(cmp_r8i8.INFO);
    addOperation(cmp_m8i8.INFO);
    addOperation(cmp_r16i16.INFO);
    addOperation(cmp_m16i16.INFO);
    addOperation(jmp_short.INFO);
    addOperation(jmp_long.INFO);
    addOperation(jmp_r16.INFO);
    addOperation(jmp_m16.INFO);
    addOperation(jo.INFO);
    addOperation(jno.INFO);
    addOperation(jc.INFO);
    addOperation(jnc.INFO);
    addOperation(jz.INFO);
    addOperation(jnz.INFO);
    addOperation(js.INFO);
    addOperation(jns.INFO);
    addOperation(jp.INFO);
    addOperation(jpe.INFO);
    addOperation(jnp.INFO);
    addOperation(jpo.INFO);
    addOperation(ja.INFO);
    addOperation(jae.INFO);
    addOperation(jb.INFO);
    addOperation(jbe.INFO);
    addOperation(je.INFO);
    addOperation(jne.INFO);
    addOperation(jna.INFO);
    addOperation(jnae.INFO);
    addOperation(jnb.INFO);
    addOperation(jnbe.INFO);
    addOperation(jg.INFO);
    addOperation(jge.INFO);
    addOperation(jl.INFO);
    addOperation(jle.INFO);
    addOperation(jng.INFO);
    addOperation(jnge.INFO);
    addOperation(jnl.INFO);
    addOperation(jnle.INFO);
    addOperation(int_.INFO);
    addOperation(lea_r16label.INFO);
    addOperation(instruction.INFO);
  }
}
