/*
 * Copyright 2012-2016 ISP RAS (http://www.ispras.ru)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.microtesk.model.metadata;

import ru.ispras.microtesk.model.data.Type;

/**
 * The MetaData interface is a common interface to be implemented by metadata object. It is needed
 * to work with collections of different metadata objects in a uniform way.
 * 
 * @author <a href="mailto:andrewt@ispras.ru">Andrei Tatarnikov</a>
 */
public interface MetaData {
  /**
   * Returns the name of the current metadata element.
   * 
   * @return Metadata element name.
   */
  String getName();

  /**
   * Returns the type associated with the metadata element or {@code null}
   * if the element has no type.
   * 
   * @return type of the metadata element or {@code null} if the element has no type.
   */
  Type getDataType();
}
